﻿Imports System.Data.SQLite
Imports System.IO

Public Class Form1

    Dim mySQLConn As SQLiteConnection
    Dim cmd As SQLiteCommand
    Dim ct As New DataTable

    Dim AlterarDados As Boolean = False
    Dim NaoOcupado As Boolean = False
    Dim GridRegistro As Integer

    Dim nomeBD As String = "ImagensDB.db3"
    Dim nomeTabela As String
    Dim iniciar As Boolean = True

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        NaoOcupado = True

        GetAlbums()
        Me.Size = New Size(1395, 777)
        Me.CenterToScreen()
        CarregaGrid()

        cboAlbumAtual.SelectedIndex = 0
        NaoOcupado = False

    End Sub

    Private Sub CarregaGrid()

        ' limpar o grid
        ct.Clear()
        dgvImagens.DataSource = Nothing
        dgvImagens.DefaultCellStyle.SelectionBackColor = Color.Yellow
        dgvImagens.DefaultCellStyle.SelectionForeColor = Color.Black

        ' fazer a conexão
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Dim da As New SQLiteDataAdapter
        Dim bs As New BindingSource

        Try

            mySQLConn.Open()

            Dim Imagens As String = nomeTabela

            'consulta sql
            Dim query As String = "SELECT * FROM " & Imagens

            cmd = New SQLiteCommand(query, mySQLConn)
            da.SelectCommand = cmd
            da.Fill(ct)
            bs.DataSource = ct

            dgvImagens.AutoSizeColumnsMode = DataGridViewAutoSizeColumnMode.Fill
            dgvImagens.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None

            dgvImagens.RowTemplate.Height = 100

            dgvImagens.DataSource = bs
            da.Update(ct)

            mySQLConn.Close()

            DirectCast(dgvImagens.Columns(6), DataGridViewImageColumn).ImageLayout = DataGridViewImageCellLayout.Stretch
            dgvImagens.RowsDefaultCellStyle.WrapMode = DataGridViewTriState.True

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Private Sub dgvImagens_CellContentClick_1(sender As Object, e As DataGridViewCellEventArgs) Handles dgvImagens.CellContentClick

        ' Exibir imagem no picturebox
        ' usando backgroundimage

        Dim img As Byte()
        Dim i As Integer = e.RowIndex
        If i < 0 Then i = 0
        img = dgvImagens.Item(6, i).Value
        Dim ms As New MemoryStream(img)
        picImagem.BackgroundImage = Image.FromStream(ms)
        picImagem.BackgroundImageLayout = ImageLayout.Stretch

    End Sub

    Private Sub dgvImagens_CellEnter(sender As Object, e As DataGridViewCellEventArgs) Handles dgvImagens.CellEnter

        NaoOcupado = True  'usado apenas como flag

        ' atualiza a tela para mostrar as informações
        Dim i As Integer = dgvImagens.CurrentRow.Index
        Dim c As Integer
        Dim v As Integer
        Dim img As Byte()

        c = dgvImagens.Item(0, i).Value
        v = ct.Rows.Count
        Label2.Text = "GridID: " & Format(i + 1, "0000") & " de " & Format(v, "0000")
        Label1.Text = "RegID: " & Format(c, "0000")

        txtUsuario.Text = dgvImagens.Item(1, i).Value ' Usuario
        txtNomeArquivo.Text = dgvImagens.Item(5, i).Value ' nomerquivo
        txtTamanhoArquivo.Text = dgvImagens.Item(4, i).Value ' tamanho arquivo
        txtDescricao.Text = dgvImagens.Item(2, i).Value ' Descrição
        txtDataHora.Text = dgvImagens.Item(3, i).Value ' Data

        txtNomeArquivo.Select(txtTamanhoArquivo.Text.Length, 0)

        img = dgvImagens.Item(6, i).Value
        Dim ms As New MemoryStream(img)
        picImagem.BackgroundImage = Image.FromStream(ms)
        picImagem.BackgroundImageLayout = ImageLayout.Stretch

        GridRegistro = dgvImagens.Item(0, i).Value

        NaoOcupado = False

    End Sub

    Private Sub btnNovaImagem_Click(sender As Object, e As EventArgs) Handles btnNovaImagem.Click

        ' Adiciona a imagem no banco de dados

        Dim nomeArquivoJpg As String = carregaArquivoJPEG()
        If nomeArquivoJpg = "" Then Exit Sub
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Try
            Dim TamanhoArquivo As UInt32
            Dim rawData() As Byte
            Dim fs As System.IO.FileStream

            ' todo - pega o nome do arquivo atual
            fs = New FileStream(nomeArquivoJpg, FileMode.Open, FileAccess.Read)
            TamanhoArquivo = fs.Length

            rawData = New Byte(TamanhoArquivo) {}
            fs.Read(rawData, 0, TamanhoArquivo)
            fs.Close()

            ' limpa o caminho e apenas pega o nome do arquivo
            nomeArquivoJpg = nomeArquivoJpg.Substring(nomeArquivoJpg.LastIndexOf("\") + 1)

            mySQLConn.Open()

            Dim Imagens As String = nomeTabela

            Dim query As String = "INSERT INTO " & Imagens & " Values(NULL, @Usuario, @Descricao, @Data, @TamanhoArquivo, @NomeArquivo, @Imagem)"

            'cmd = New SQLiteCommand(query, mySQLConn)
            cmd.Connection = mySQLConn
            cmd.CommandText = query

            cmd.Parameters.AddWithValue("@Usuario", "Username")
            cmd.Parameters.AddWithValue("@Descricao", "Descrição da Imagem")
            cmd.Parameters.AddWithValue("@Data", Now.Date.ToShortDateString)
            cmd.Parameters.AddWithValue("@TamanhoArquivo", TamanhoArquivo.ToString)
            cmd.Parameters.AddWithValue("@NomeArquivo", nomeArquivoJpg)
            cmd.Parameters.AddWithValue("@Imagem", rawData)

            cmd.ExecuteNonQuery()

            mySQLConn.Close()
            MsgBox("Arquivo imagem salvo como BLOB")

            NaoOcupado = True
            CarregaGrid()
            NaoOcupado = False

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Private Sub btnExportarImagem_Click(sender As Object, e As EventArgs) Handles btnExportarImagem.Click

        ' Exportar a imagem para o disco
        Dim nomeArquivoJpg As String = SalvaArquivoJPEG()
        If nomeArquivoJpg = "" Then Exit Sub

        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Dim sqlReader As SQLiteDataReader
        Dim rawData() As Byte
        Dim TamanhoArquivo As Int32
        Dim fs As FileStream

        Try

            mySQLConn.Open()

            Dim Imagens As String = nomeTabela

            Dim query = "SELECT * FROM " & Imagens & " WHERE (FileID = '" & GridRegistro.ToString & "')"
            cmd.Connection = mySQLConn
            cmd.CommandText = query

            sqlReader = cmd.ExecuteReader

            sqlReader.Read()

            TamanhoArquivo = Val(txtTamanhoArquivo.Text)

            rawData = New Byte(TamanhoArquivo) {}

            sqlReader.GetBytes(sqlReader.GetOrdinal("FileRaw"), 0, rawData, 0, TamanhoArquivo)

            'Dim fname As String = TextBox2.Text

            fs = New FileStream(nomeArquivoJpg, FileMode.OpenOrCreate, FileAccess.Write)
            fs.Write(rawData, 0, TamanhoArquivo)
            fs.Close()

            sqlReader.Close()
            mySQLConn.Close()

            MsgBox("Arquivo salvo com sucesso...")

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Private Sub btnDeletarImagem_Click(sender As Object, e As EventArgs) Handles btnDeletarImagem.Click

        '  Deleta a imagem selecionada do grid e do banco de dados
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD
        Dim sqlReader As SQLiteDataReader

        Try

            mySQLConn.Open()

            Dim Imagens As String = nomeTabela

            Dim query As String = "DELETE FROM " & Imagens & " WHERE FileID = '" & GridRegistro.ToString & "'"


            cmd = New SQLiteCommand(query, mySQLConn)
            sqlReader = cmd.ExecuteReader

            MsgBox("Imagem Deletada com sucesso...")
            mySQLConn.Close()

            NaoOcupado = True
            CarregaGrid()
            NaoOcupado = False

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Private Sub btnLogout_Click(sender As Object, e As EventArgs) Handles btnLogout.Click
        ' Sair do programa
        If (MessageBox.Show("Deseja Encerrar o programa?", "Encerrar", MessageBoxButtons.YesNo) = DialogResult.Yes) Then
            Application.ExitThread()
        End If

    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        ' Sair do programa
        If (MessageBox.Show("Deseja Encerrar o programa?", "Encerrar", MessageBoxButtons.YesNo) = DialogResult.Yes) Then
            Application.ExitThread()
        End If
    End Sub

    Private Sub btnAtualizarRegistro_Click(sender As Object, e As EventArgs) Handles btnAtualizarRegistro.Click

        ' atualiza os campos
        ' Deveremos permitir o usuário atualizar cada campo
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Dim sqlReader As SQLiteDataReader

        Try
            mySQLConn.Open()
            Dim Imagens As String = nomeTabela

            Dim query As String =
                "UPDATE " & Imagens & " SET " _
                & "User='" & txtUsuario.Text _
                & "',Description='" & txtDescricao.Text _
                & "',DateTime='" & txtDataHora.Text _
                & "',FileSize='" & txtTamanhoArquivo.Text _
                & "',FileName='" & txtNomeArquivo.Text _
                & "' WHERE FileID = '" & GridRegistro.ToString & "'"

            cmd = New SQLiteCommand(query, mySQLConn)
            sqlReader = cmd.ExecuteReader

            mySQLConn.Close()
            MsgBox("Dados Atualizados com sucesso...")

            NaoOcupado = True
            CarregaGrid()
            NaoOcupado = False

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Private Sub txtProcurarImagens_TextChanged(sender As Object, e As EventArgs) Handles txtProcurarImagens.TextChanged
        Dim dv As New DataView(ct)
        dv.RowFilter = String.Format("Description LIKE '%{0}%'", txtProcurarImagens.Text)
        dgvImagens.DataSource = dv
    End Sub

    Private Function carregaArquivoJPEG() As String

        ' exibir o OpenFileDialog
        Dim ofd1 As New OpenFileDialog()
        ofd1.Filter = "JPEG Files|*.jpg"
        ofd1.Title = "Selecione um arquivo do tipo JPEG"

        If ofd1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then

            ' pega o nome do arquivo
            Return ofd1.FileName
            'Return jpgName.Substring(jpgName.LastIndexOf("\") + 1)
        Else
            Return Nothing
        End If

    End Function

    Private Function SalvaArquivoJPEG() As String

        ' exibie o OpenFileDialog
        Dim sfd1 As New SaveFileDialog()
        sfd1.Filter = "JPEG Files|*.jpg"
        sfd1.Title = "Selecione um arquivo do tipo JPEG"

        If sfd1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            ' pega o nome do arquivo
            Return sfd1.FileName
        Else
            Return Nothing
        End If

    End Function

    Private Sub GetAlbums()

        ' Preencha o Combobox1 e o nome do album atual e nome da tabela
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Dim sqlReader As SQLiteDataReader

        Try
            mySQLConn.Open()
            Dim query As String = "SELECT * FROM albums"

            cboAlbumAtual.Items.Clear()
            cboImagens.Items.Clear()

            cmd = New SQLiteCommand(query, mySQLConn)
            sqlReader = cmd.ExecuteReader

            While sqlReader.Read
                cboAlbumAtual.Items.Add(sqlReader("AlbumName"))
                cboImagens.Items.Add(sqlReader("AlbumTable"))
            End While

            mySQLConn.Close()

            nomeTabela = cboImagens.Items(cboAlbumAtual.SelectedItem).ToString

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Private Sub cboAlbumAtual_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboAlbumAtual.SelectedIndexChanged

        cboImagens.SelectedIndex = cboAlbumAtual.SelectedIndex

        If iniciar = False Then
            NaoOcupado = True
            nomeTabela = cboImagens.Text
            CarregaGrid()
            NaoOcupado = False
        End If

        cboAlbumAtual.Select(cboAlbumAtual.Text.Length, 0)
        iniciar = False

    End Sub

    Private Sub txtDescricao_Enter(sender As Object, e As EventArgs) Handles txtDescricao.Enter
        ' Poe o curso no local correto
        txtDescricao.Select(txtDescricao.Text.Length, 0)
    End Sub

    Private Sub txtUsuario_Enter(sender As Object, e As EventArgs) Handles txtUsuario.Enter
        ' Poe o curso no local correto
        txtUsuario.Select(txtUsuario.Text.Length, 0)
    End Sub

    Private Sub txtNomeArquivo_Enter(sender As Object, e As EventArgs) Handles txtNomeArquivo.Enter
        ' Poe o curso no local correto
        txtNomeArquivo.Select(txtNomeArquivo.Text.Length, 0)
    End Sub

    Private Sub cboAlbumAtual_KeyPress(sender As Object, e As KeyPressEventArgs) Handles cboAlbumAtual.KeyPress
        Dim i As Integer
        For i = 0 To cboAlbumAtual.Items.Count - 1
            ' para o pressionar
            e.Handled = True
        Next i

    End Sub

    Private Sub btnNovoAlbum_Click(sender As Object, e As EventArgs) Handles btnNovoAlbum.Click
        If txtNomeAlbum.Text = "" Then
            MsgBox("O nome do Álbum esta em branco", MessageBoxIcon.Information, "Ajuda")
            Exit Sub
        End If

        ' Pega o nome da tabela do combobox2 - não precisa procurar no banco de dados
        Dim nomeDaTabela As String = cboImagens.Items(cboImagens.Items.Count - 1)

        ' Prepara nosso novo nome do album o qual o usuario deseja
        Dim nomeDoAlbum As String = txtNomeAlbum.Text
        ' Prepara o nome do album para consulta
        nomeDoAlbum = QuoteString(nomeDoAlbum)

        ' Prepara nossa nova tabela com o novo nome
        If Len(nomeDaTabela) < 7 Then
            nomeDaTabela = "image" & Val(Mid(nomeDaTabela, 6, 1) + 1).ToString
        Else
            nomeDaTabela = "image" & Val(Mid(nomeDaTabela, 6, 2) + 1).ToString
        End If

        AtualizarAlbuns(nomeDaTabela, nomeDoAlbum)
        CriarNovaTabela(nomeDaTabela)

        cboAlbumAtual.Items.Add(nomeDoAlbum)
        cboImagens.Items.Add(nomeDaTabela)

    End Sub

    Public Sub AtualizarAlbuns(minhaTabela As String, meuAlbum As String)

        ' Atualiza a tabela Albums
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Try

            mySQLConn.Open()

            Dim Imagens As String = "albums"

            Dim query As String = "INSERT INTO " & Imagens & " Values(NULL, @AlbumName, @AlbumTable)"

            'cmd = New SQLiteCommand(query, mySQLConn)
            cmd.Connection = mySQLConn
            cmd.CommandText = query

            cmd.Parameters.AddWithValue("@AlbumName", meuAlbum)
            cmd.Parameters.AddWithValue("@AlbumTable", minhaTabela)

            cmd.ExecuteNonQuery()

            mySQLConn.Close()

            txtNomeAlbum.Text = ""
            MsgBox("Álbum criado com sucesso...")

            NaoOcupado = True
            CarregaGrid()
            NaoOcupado = False

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Public Sub CriarNovaTabela(minhaTabela As String)

        ' Cria uma nova Tabela para armazenar novas imagens baseado no nome do album
        mySQLConn = New SQLiteConnection
        mySQLConn.ConnectionString = "Data Source=" & nomeBD

        Try
            mySQLConn.Open()
            Dim Imagens As String = minhaTabela

            Dim query As String = "CREATE TABLE " & Chr(34) & Imagens & Chr(34) & " (" _
                                 & "FileID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT," _
                                 & "User TEXT NOT NULL, Description Text NOT NULL," _
                                 & "DateTime TEXT NOT NULL, FileSize TEXT NOT NULL," _
                                 & "FileName TEXT NOT NULL, FileRaw BLOB)"

            'Dim query As String = "CREATE TABLE " & Chr(34) & Imagens & Chr(34) & " (" _
            '                     & "ArquivoID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT," _
            '                     & "Usuario TEXT NOT NULL, Descricao Text NOT NULL," _
            '                     & "Data TEXT NOT NULL, TamanhoArquivo TEXT NOT NULL," _
            '                     & "NomeArquivo TEXT NOT NULL, Imagem BLOB)"

            cmd.Connection = mySQLConn
            cmd.CommandText = query
            cmd.ExecuteNonQuery()

            mySQLConn.Close()

            MsgBox("Tabela Criada com sucesso...")

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            mySQLConn.Dispose()
        End Try

    End Sub

    Public Function QuoteString(Value As String) As String
        ' prepara a string para ser adicionada para uma consulta sql
        QuoteString = Replace(Value, "'", "''")
    End Function

End Class
